import processing.core.*; 
import processing.xml.*; 

import krister.Ess.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class jeu extends PApplet {



AudioChannel[] pop = new AudioChannel[3];
int freqEchant=44100;

ArrayList particles = new ArrayList(0);
ArrayList ennemies = new ArrayList(0);

int t=0;
int pts=0;
float freq=500;

int phase=0;

public void setup() {
  smooth();
  frameRate(50);
  size(500, 500);
  for (int i=0;i<10;i++) {
    particles.add(new Particle());
  }
  ennemies.add(new Ennemy());
  textAlign(CENTER);
  textSize(20);

  Ess.start(this);
  pop[0]=new AudioChannel();
  pop[0].sampleRate(freqEchant);
  pop[1]=new AudioChannel();
  pop[1].sampleRate(freqEchant);
  pop[2]=new AudioChannel();
  pop[2].sampleRate(freqEchant);
  int sLength=500;
  pop[0].initChannel(sLength);
  pop[0].samples=generatePop(1, sLength);
  pop[1].initChannel(sLength);
  pop[1].samples=generatePop(5, sLength);
  pop[2].initChannel(sLength);
  pop[2].samples=generatePop(10, sLength);
}

public float[] generatePop(int i, int sL) {
  float[] son = new float[sL];
  float freqBase = 1500-i*100;
  for (int s=0;s<son.length;s++) {
    float freq = freqBase + pow((float)(son.length-s)/son.length, 5)*1000;
    son[s]=sin((float)s*TWO_PI/(freqEchant/freq))*((float)(son.length-s)/son.length)*min(1, (float)s*2/sL);
  }
  return son;
}

public void phaseA() {
  t++;
  freq=max(10, freq-0.005f);
  if (t%floor(freq)==0) {
    particles.add(new Particle());
  }
  if (t%(floor(freq*4))==0) {
    ennemies.add(new Ennemy());
  }  
  background(0);
  for (int i=0;i<particles.size();i++) {
    ((Particle)particles.get(i)).move();
    ((Particle)particles.get(i)).display();
    ((Particle)particles.get(i)).d-=0.5f;
    if (((Particle)particles.get(i)).d<(float)((Particle)particles.get(i)).tail/2) {
      fill(0xFF, 0x00, 0x00);
      noStroke();
      ellipse(((Particle)particles.get(i)).prev[0].x, ((Particle)particles.get(i)).prev[0].y, 50, 50);      
      particles.remove(i);
      particles.add(new Particle());
      pts--;
      pop[0].play(1);
    }
  }
  for (int i=0;i<ennemies.size();i++) {
    ((Ennemy)ennemies.get(i)).move();
    ((Ennemy)ennemies.get(i)).display();
    for (int j=0;j<particles.size();j++) {
      if (sq(((Particle)particles.get(j)).prev[0].x-((Ennemy)ennemies.get(i)).prev[0].x) + sq(((Particle)particles.get(j)).prev[0].y-((Ennemy)ennemies.get(i)).prev[0].y) < sq(((Particle)particles.get(j)).tail/2+((Ennemy)ennemies.get(i)).tail/2)) {
        fill(0x00, 0xFF, 0x00);
        noStroke();
        ellipse(((Particle)particles.get(j)).prev[0].x, ((Particle)particles.get(j)).prev[0].y, 50, 50);
        particles.remove(j);
        pts++;
        pop[1].play(1);
      }
    }
    if (dist(mouseX, mouseY, ((Ennemy)ennemies.get(i)).prev[0].x, ((Ennemy)ennemies.get(i)).prev[0].y)<((Ennemy)ennemies.get(i)).tail/2) {
      phase=2;
      pop[2].play(1);
    }
  }
  fill(0xFF, 0x00, 0x00, 0x80);
  noStroke();
  rect(0, 0, width, 5);
  rect(0, 5, 5, height);
  rect(5, height-5, width-10, 5);
  rect(width-5, 5, 5, height-5);
  if (mouseX<5||mouseY<5||mouseX>width-5||mouseY>height-5) {
    fill(0xFF, 0x00, 0x00);
    text(pts, 30, 40);
    text("keep the cursor inside the screen !", width/2, 55);
    if (t%20==0) pts--;
  }
  else {
    fill(0x00, 0xFF, 0x00);
    text(pts, 30, 40);
  }
  while (particles.size ()<5) {
    particles.add(new Particle());
  }
}

public void draw() {
  if (phase==0) {    
    background(0);
    fill(0xFF);
    text("avoid all the creatures with your mouse", 0, height*2/5, width, height);
    text("but make sure yellow and red ones collide", 0, height*3/5, width, height);
  }
  if (phase==1) {
    phaseA();
  }
  if (phase==2) {
    background(0);
    fill(0xFF);
    text("your score : "+pts, 0, height*2/5, width, height);
  }
}

public void mousePressed() {
  if (phase==0) {
    pop[2].play(1);    
    phase=1;
    particles = new ArrayList(0);
    ennemies = new ArrayList(0);
    pts=0;    
    for (int i=0;i<10;i++) {
      particles.add(new Particle());
    }
    ennemies.add(new Ennemy());
  }
  if (phase==2) {  
    pop[2].play(1);    
    phase=0;
  }
}

class Particle {
  PVector pos;
  int tail=30;
  PVector[] prev = new PVector[tail];
  float a, d;
  Particle() {
    d=sqrt(sq(width)+sq(height))+random(200);
    a=random(TWO_PI);    
    for (int i=0;i<tail;i++) {
      prev[i]=new PVector(mouseX+cos(a)*d, mouseY+sin(a)*d);
    }
  }
  public void updateTail() {    
    for (int i=tail-1;i>0;i--) {
      prev[i].x=prev[i-1].x;
      prev[i].y=prev[i-1].y;
    }
  }
  public void move() {
    a+=vrMax(a, atan2(prev[0].y-mouseY, prev[0].x-mouseX), TWO_PI)*2/3;
    while (a<0||a>TWO_PI)a=(a+TWO_PI)%TWO_PI;
    prev[0].x=(prev[0].x)*2/3+(mouseX+cos(a)*d)*1/3;
    prev[0].y=(prev[0].y)*2/3+(mouseY+sin(a)*d)*1/3;
    updateTail();
  }

  public void display() {
    if (prev[0].x>0&&prev[0].x<width&&prev[0].y>0&&prev[0].y<height) {
      for (int i=tail-1;i>=0;i--) {
        if (i==0) {
          stroke(0xFF, 0xA0);
          fill(0xFF, 0xFF, 0x00);
          ellipse(prev[i].x, prev[i].y, tail-i, tail-i);
          noStroke();
          fill(0x0);
          ellipse(prev[i].x+(float)tail*cos(a+PI+HALF_PI/2)/3, prev[i].y+(float)tail*sin(a+PI+HALF_PI/2)/3, (float)tail/5, (float)tail/5);
          ellipse(prev[i].x+(float)tail*cos(a+PI-HALF_PI/2)/3, prev[i].y+(float)tail*sin(a+PI-HALF_PI/2)/3, (float)tail/5, (float)tail/5);
        }
        else {
          noStroke();
          fill(0x80, 0x85-i*0x80/tail, 0x00, 0xFF-i*0xFF/tail);
          ellipse(prev[i].x, prev[i].y, tail-i, tail-i);
        }
      }
    }
    else {
      noStroke();
      fill(0x80, 0x80, 0x00);
      rect(constrain(prev[0].x, 0, width), constrain(prev[0].y, 0, height), 5, 5);
    }
  }
}

class Ennemy {
  PVector pos;
  int tail=40;
  PVector[] prev = new PVector[tail];
  float vX, vY;  
  Ennemy() {
    vX=random(-1, 1);
    vY=random(-1, 1);    
    for (int i=0;i<tail;i++) {
      prev[i]=new PVector(random(width-10)+5, random(height-10)+5);
    }
    updateTail();
  }
  public void updateTail() {    
    for (int i=tail-1;i>0;i--) {
      prev[i].x=prev[i-1].x;
      prev[i].y=prev[i-1].y;
    }
  }
  public void move() {
    prev[0].x+=vX;
    prev[0].y+=vY;
    if (prev[0].x-tail/8<0||prev[0].x+tail/8>width) vX*=-1;
    if (prev[0].y-tail/8<0||prev[0].y+tail/8>height) vY*=-1;
    prev[0].x+=vX;
    prev[0].y+=vY;
    updateTail();
  }
  public void display() {
    for (int i=tail-1;i>=0;i--) {
      if (i==0) {
        stroke(0xFF, 0xA0);
        fill(0xFF, 0x00, 0x00);
      }
      else {
        noStroke();
        fill(0x85, 0x00, 0x00, 0xFF-i*0xFF/tail);
      }
      ellipse(prev[i].x, prev[i].y, (float)tail/2-(float)i/2, (float)tail/2-(float)i/2);
      if (i==0) {
        noStroke();
        fill(0x0);
        float a=atan2(vY, vX);
        ellipse(prev[i].x+(float)tail*cos(a+HALF_PI/2)/6, prev[i].y+(float)tail*sin(a+HALF_PI/2)/6, (float)tail/8, (float)tail/8);
        ellipse(prev[i].x+(float)tail*cos(a-HALF_PI/2)/6, prev[i].y+(float)tail*sin(a-HALF_PI/2)/6, (float)tail/8, (float)tail/8);
      }
    }
  }
}

public float vrMax(float a, float b, float m) {
  float d1=b-a;
  if (d1>m/2) {
    d1=d1-m;
  }
  if (d1<-m/2) {
    d1=d1+m;
  }
  return d1;
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#D4D0C8", "jeu" });
  }
}
